Unit AFP1R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure AFP1R(var A :Array of Real; N :Integer; M :Integer;
                var W :Array of Real);

implementation

procedure AFP1R(var A :Array of Real; N :Integer; M :Integer;
                var W :Array of Real);
var
I,J,B,F :Integer;
C,E,G,H,O,V,BG :Real;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15;
begin
for B:=1 to N do
 begin
  if ( B <> M ) 
   then goto _1;
  W[B-1] := A[(B-1)+(B-1)*N];
  A[(B-1)+(B-1)*N] := 0.0;
  goto _15;
_1:
  for J:=B to M do
   begin
    W[J-1] := A[(B-1)+(J-1)*N];
_2:
   end;
  C := 0.0;
  for J:=B to M do
   begin
    V := Abs(W[J-1]);
    if ( C >= V ) 
     then goto _3;
    C := V;
_3:
   end;
  if ( C = 0.0 ) 
   then goto _14;
  O := 1.0/C;
  G := 0.0;
  for J:=B to M do
   begin
    G := G+W[J-1]*O*W[J-1]*O;
_4:
   end;
  C := Sqrt(G)*C;
  G := 1.0/C;
  for J:=B to M do
   begin
    W[J-1] := W[J-1]*G;
_5:
   end;
  if ( W[B-1] <> 0.0 ) 
   then goto _6;
  H := 1.0;
  W[B-1] := 1.0;
  goto _8;
_6:
  H := Sign(1.0,W[B-1]);
  G := 1.0+Abs(W[B-1]);
  W[B-1] := H*G;
  G := 1.0/Sqrt(G);
  for J:=B to M do
   begin
    W[J-1] := W[J-1]*G;
_7:
   end;
_8:
  E := -C*H;
  for J:=B to M do
   begin
    A[(B-1)+(J-1)*N] := W[J-1];
_9:
   end;
  if ( B = N ) 
   then goto _13;
  F := B+1;
  for I:=F to N do
   begin
    BG := 0.0;
    for J:=B to M do
     begin
      BG := BG+A[(I-1)+(J-1)*N]*W[J-1];
_10:
     end;
    for J:=B to M do
     begin
      A[(I-1)+(J-1)*N] := A[(I-1)+(J-1)*N]-BG*W[J-1];
_11:
     end;
_12:
   end;
_13:
  W[B-1] := E;
_14:
 end;
_15:
end;

end.
